#include <Application.h>
#include <StorageKit.h>
#include <be/add-ons/tracker/TrackerAddon.h>
void process_refs(entry_ref ref, BMessage *msg, void *)
{
	BNode node(&ref);	entry_ref file_ref;
	
	char toRestore[B_MIME_TYPE_LENGTH];
	char toBackup[B_MIME_TYPE_LENGTH];	
	
	for (int refs=0; msg->FindRef("refs", refs, &file_ref) == B_NO_ERROR; refs++)	{
		node.SetTo(&file_ref);	
		size_t backupSize  = node.ReadAttr("BEOS:TYPE",  B_MIME_TYPE, 0, toBackup,  B_MIME_TYPE_LENGTH - 1 );
		size_t restoreSize = node.ReadAttr("BackupType", B_MIME_TYPE, 0, toRestore, B_MIME_TYPE_LENGTH - 1 );
		if (restoreSize != B_ENTRY_NOT_FOUND)	{
			node.WriteAttr ("BEOS:TYPE", B_MIME_TYPE, 0, toRestore, restoreSize);
			node.RemoveAttr("BackupType");		}
		else	{
			node.WriteAttr("BackupType", B_MIME_TYPE, 0, toBackup, backupSize);
			node.WriteAttr("BEOS:TYPE",  B_MIME_TYPE, 0, "text/plain", 11);
}	}	}
int main() 
{ 	new BApplication("application/x-detroitpunk.totext");
	delete be_app;   }